Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 2528)
@@ -596,17 +701,17 @@
       !                                                !---------------------!
       IF( kt == nitend ) THEN
-          IF(ln_bdy_tra_frs .or. ln_bdy_ice_frs) CALL iom_close( numbdyt )              ! Closing of the 3 files
-          IF(ln_bdy_dyn_frs) CALL iom_close( numbdyu )
-          IF(ln_bdy_dyn_frs) CALL iom_close( numbdyv )
+          IF(ln_tra_frs .or. ln_ice_frs) CALL iom_close( numbdyt )              ! Closing of the 3 files
+          IF(ln_dyn_frs) CALL iom_close( numbdyu )
+          IF(ln_dyn_frs) CALL iom_close( numbdyv )
       ENDIF
       !
-      ENDIF ! ln_bdy_dyn_frs .OR. ln_bdy_tra_frs
-
-   END SUBROUTINE bdy_dta
-
-
-   SUBROUTINE bdy_dta_bt( kt, jit )
+      ENDIF ! ln_dyn_frs .OR. ln_tra_frs
+      !
+   END SUBROUTINE bdy_dta_frs
+
+
+   SUBROUTINE bdy_dta_fla( kt, jit, icycl )
       !!---------------------------------------------------------------------------
-      !!                      ***  SUBROUTINE bdy_dta_bt  ***
+      !!                      ***  SUBROUTINE bdy_dta_fla  ***
       !!                    
       !! ** Purpose :   Read unstructured boundary data for Flather condition
@@ -620,4 +725,5 @@
       INTEGER, INTENT( in ) ::   kt          ! ocean time-step index
       INTEGER, INTENT( in ) ::   jit         ! barotropic time step index
+      INTEGER, INTENT( in ) ::   icycl       ! number of cycles need for final file close
       !                                      ! (for timesplitting option, otherwise zero)
       !!
@@ -639,10 +745,10 @@
       REAL(wp), DIMENSION(jpbtime)      ::   zstepr             ! REAL time array from data files
       REAL(wp), DIMENSION(jpbdta,1)     ::   zdta               ! temporary array for data fields
-      CHARACTER(LEN=80), DIMENSION(3)   ::   clfile
+      CHARACTER(LEN=80), DIMENSION(6)   ::   clfile
       CHARACTER(LEN=70 )                ::   clunits            ! units attribute of time coordinate
       !!---------------------------------------------------------------------------
 
-!!gm   add here the same style as in bdy_dta
-!!gm      clearly bdy_dta_bt and bdy_dta  can be combined...   
+!!gm   add here the same style as in bdy_dta_frs
+!!gm      clearly bdy_dta_fla and bdy_dta_frs  can be combined...   
 !!gm      too many things duplicated in the read of data...   simplification can be done
 
@@ -671,5 +777,5 @@
       itimer = itimer + jit*rdt/REAL(nn_baro,wp)      ! in non-climatological case
 
-      IF ( ln_bdy_tides ) THEN
+      IF ( ln_tides ) THEN
 
          ! -------------------------------------!
@@ -681,5 +787,5 @@
       ENDIF
 
-      IF ( ln_bdy_dyn_fla ) THEN
+      IF ( ln_dyn_fla ) THEN
 
          ! -------------------------------------!
@@ -688,5 +794,5 @@
 
       !                                                !-------------------!
-      IF( kt == nit000 ) THEN                          !  First call only  !
+      IF( kt == nit000 .and. jit ==2 ) THEN            !  First call only  !
          !                                             !-------------------!
          istep_bt(:) = 0
@@ -698,11 +804,11 @@
 
         IF(lwp) WRITE(numout,*)
-        IF(lwp) WRITE(numout,*)    'bdy_dta_bt :Initialize unstructured boundary data for barotropic variables.'
+        IF(lwp) WRITE(numout,*)    'bdy_dta_fla :Initialize unstructured boundary data for barotropic variables.'
         IF(lwp) WRITE(numout,*)    '~~~~~~~' 
 
-        IF( nbdy_dta == 0 ) THEN
+        IF( nn_dtactl == 0 ) THEN
           IF(lwp) WRITE(numout,*)  'Bdy data are taken from initial conditions'
 
-        ELSEIF (nbdy_dta == 1) THEN
+        ELSEIF (nn_dtactl == 1) THEN
           IF(lwp) WRITE(numout,*)  'Bdy data are read in netcdf files'
 
@@ -712,20 +818,20 @@
                                                      ! necessary time dumps in file are included
 
-          clfile(1) = filbdy_data_bt_T
-          clfile(2) = filbdy_data_bt_U
-          clfile(3) = filbdy_data_bt_V
-
-          DO igrd = 1,3
+          clfile(4) = cn_dta_fla_T
+          clfile(5) = cn_dta_fla_U
+          clfile(6) = cn_dta_fla_V
+
+          DO igrd = 4,6
 
             CALL iom_open( clfile(igrd), inum )
-            CALL iom_gettime( inum, zstepr, kntime=ntimes_bdy, cdunits=clunits ) 
+            CALL iom_gettime( inum, zstepr, kntime=ntimes_bdy_bt, cdunits=clunits ) 
 
             SELECT CASE( igrd )
-               CASE (1) 
-                  numbdyt = inum
-               CASE (2) 
-                  numbdyu = inum
-               CASE (3) 
-                  numbdyv = inum
+               CASE (4) 
+                  numbdyt_bt = inum
+               CASE (5) 
+                  numbdyu_bt = inum
+               CASE (6) 
+                  numbdyv_bt = inum
             END SELECT
 
@@ -757,5 +863,5 @@
 
             ! Check that time array increases (or interp will fail):
-            DO it = 2, ntimes_bdy
+            DO it = 2, ntimes_bdy_bt
                IF ( zstepr(it-1) >= zstepr(it) ) THEN
                   CALL ctl_stop('Time array in unstructured boundary data file', &
@@ -766,5 +872,5 @@
             END DO
 
-            IF ( .NOT. ln_bdy_clim ) THEN
+            IF ( .NOT. ln_clim ) THEN
                ! Check that times in file span model run time:
 
@@ -778,38 +884,30 @@
                ! The same applies to the last time level: see setting of lect below.
 
-               IF ( ntimes_bdy == 1 ) CALL ctl_stop( &
+               IF ( ntimes_bdy_bt == 1 ) CALL ctl_stop( &
                     'There is only one time dump in data files', &
-                    'Set ln_bdy_clim=.true. in namelist for constant bdy forcing.' )
+                    'Set ln_clim=.true. in namelist for constant bdy forcing.' )
 
                zinterval_s = zstepr(2) - zstepr(1)
-               zinterval_e = zstepr(ntimes_bdy) - zstepr(ntimes_bdy-1)
-
-               IF ( zstepr(1) - zinterval_s / 2.0 > 0 ) THEN	          
-                  IF(lwp) WRITE(numout,*) 'First bdy time relative to nit000:', zstepr(1)
-                  IF(lwp) WRITE(numout,*) 'Interval between first two times: ', zinterval_s
-                  CALL ctl_stop( 'First data time is after start of run', & 
-                       'by more than half a meaning period', &
-                       'Check file: ' // TRIM(clfile(igrd)) )
+               zinterval_e = zstepr(ntimes_bdy_bt) - zstepr(ntimes_bdy_bt-1)
+
+               IF( zstepr(1) + zoffset > 0 ) THEN
+                     WRITE(ctmp1,*) 'Check file: ', clfile(igrd)
+                     CALL ctl_stop( 'First time dump in bdy file is after model initial time', ctmp1 )
                END IF
-
-               IF ( zstepr(ntimes_bdy) + zinterval_e / 2.0 < totime ) THEN
-                  IF(lwp) WRITE(numout,*) 'Last bdy time relative to nit000:', zstepr(ntimes_bdy)
-                  IF(lwp) WRITE(numout,*) 'Interval between last two times: ', zinterval_e
-                  CALL ctl_stop( 'Last data time is before end of run', & 
-                       'by more than half a meaning period', &
-                       'Check file: ' // TRIM(clfile(igrd))  )
+               IF( zstepr(ntimes_bdy_bt) + zoffset < totime ) THEN
+                     WRITE(ctmp1,*) 'Check file: ', clfile(igrd)
+                     CALL ctl_stop( 'Last time dump in bdy file is before model final time', ctmp1 )
                END IF
-
-            END IF ! .NOT. ln_bdy_clim
-
-            IF ( igrd .EQ. 1) THEN
+            END IF ! .NOT. ln_clim
+
+            IF ( igrd .EQ. 4) THEN
               ntimes_bdyt = ntimes_bdy_bt
               zoffsett = zoffset
               istept(:) = INT( zstepr(:) + zoffset )
-            ELSE IF (igrd .EQ. 2) THEN
+            ELSE IF (igrd .EQ. 5) THEN
               ntimes_bdyu = ntimes_bdy_bt
               zoffsetu = zoffset
               istepu(:) = INT( zstepr(:) + zoffset )
-            ELSE IF (igrd .EQ. 3) THEN
+            ELSE IF (igrd .EQ. 6) THEN
               ntimes_bdyv = ntimes_bdy_bt
               zoffsetv = zoffset
@@ -840,5 +938,5 @@
 
       ! Check number of time dumps:              
-          IF (ln_bdy_clim) THEN
+          IF (ln_clim) THEN
             SELECT CASE ( ntimes_bdy_bt )
             CASE( 1 )
@@ -852,5 +950,5 @@
             CASE DEFAULT
               CALL ctl_stop( &
-                'For climatological boundary forcing (ln_bdy_clim=.true.),',&
+                'For climatological boundary forcing (ln_clim=.true.),',&
                 'bdy data files must contain 1 or 12 time dumps.' )
             END SELECT
@@ -865,35 +963,35 @@
           nbdy_b_bt = it
 
-          WRITE(numout,*) 'Time offset is ',zoffset
-          WRITE(numout,*) 'First record to read is ',nbdy_b_bt
-
-        ENDIF ! endif (nbdy_dta == 1)
-
-      ! 1.2  Read first record in file if necessary (ie if nbdy_dta == 1)
+          IF(lwp) WRITE(numout,*) 'Time offset is ',zoffset
+          IF(lwp) WRITE(numout,*) 'First record to read is ',nbdy_b_bt
+
+        ENDIF ! endif (nn_dtactl == 1)
+
+      ! 1.2  Read first record in file if necessary (ie if nn_dtactl == 1)
       ! *****************************************************************
 
-        IF ( nbdy_dta == 0) THEN
+        IF ( nn_dtactl == 0) THEN
           ! boundary data arrays are filled with initial conditions
-          igrd = 2            ! U-points data 
+          igrd = 5            ! U-points data 
           DO ib = 1, nblen(igrd)              
             ubtbdy(ib) = un(nbi(ib,igrd), nbj(ib,igrd), 1)
           END DO
 
-          igrd = 3            ! V-points data 
+          igrd = 6            ! V-points data 
           DO ib = 1, nblen(igrd)              
             vbtbdy(ib) = vn(nbi(ib,igrd), nbj(ib,igrd), 1)
           END DO
 
-          igrd = 1            ! T-points data 
+          igrd = 4            ! T-points data 
           DO ib = 1, nblen(igrd)              
             sshbdy(ib) = sshn(nbi(ib,igrd), nbj(ib,igrd))
           END DO
 
-        ELSEIF (nbdy_dta == 1) THEN
+        ELSEIF (nn_dtactl == 1) THEN
  
         ! Set first record in the climatological case:   
-          IF ((ln_bdy_clim).AND.(ntimes_bdy_bt==1)) THEN
+          IF ((ln_clim).AND.(ntimes_bdy_bt==1)) THEN
             nbdy_a_bt = 1
-          ELSEIF ((ln_bdy_clim).AND.(ntimes_bdy_bt==iman)) THEN
+          ELSEIF ((ln_clim).AND.(ntimes_bdy_bt==iman)) THEN
             nbdy_b_bt = 0
             nbdy_a_bt = imois
@@ -904,15 +1002,15 @@
          ! Open Netcdf files:
 
-          CALL iom_open ( filbdy_data_bt_T, numbdyt_bt )
-          CALL iom_open ( filbdy_data_bt_U, numbdyu_bt )
-          CALL iom_open ( filbdy_data_bt_V, numbdyv_bt )
+          CALL iom_open ( cn_dta_fla_T, numbdyt_bt )
+          CALL iom_open ( cn_dta_fla_U, numbdyu_bt )
+          CALL iom_open ( cn_dta_fla_V, numbdyv_bt )
 
          ! Read first record:
           ipj=1
-          igrd=1
+          igrd=4
           ipi=nblendta(igrd)
 
           ! ssh
-          igrd=1
+          igrd=4
           IF ( nblendta(igrd) .le. 0 ) THEN 
             idvar = iom_varid( numbdyt_bt,'sossheig' )
@@ -929,5 +1027,5 @@
  
           ! u-velocity
-          igrd=2
+          igrd=5
           IF ( nblendta(igrd) .le. 0 ) THEN 
             idvar = iom_varid( numbdyu_bt,'vobtcrtx' )
@@ -944,5 +1042,5 @@
 
           ! v-velocity
-          igrd=3
+          igrd=6
           IF ( nblendta(igrd) .le. 0 ) THEN 
             idvar = iom_varid( numbdyv_bt,'vobtcrty' )
@@ -961,5 +1059,5 @@
  
         ! In the case of constant boundary forcing fill bdy arrays once for all
-        IF ((ln_bdy_clim).AND.(ntimes_bdy_bt==1)) THEN
+        IF ((ln_clim).AND.(ntimes_bdy_bt==1)) THEN
 
           ubtbdy  (:) = ubtbdydta  (:,2)
@@ -979,10 +1077,10 @@
       ! -------------------- !
 
-      IF ((nbdy_dta==1).AND.(ntimes_bdy_bt>1)) THEN 
+      IF ((nn_dtactl==1).AND.(ntimes_bdy_bt>1)) THEN 
 
       ! 2.1 Read one more record if necessary
       !**************************************
 
-        IF ( (ln_bdy_clim).AND.(imois/=nbdy_b_bt) ) THEN ! remember that nbdy_b_bt=0 for kt=nit000
+        IF ( (ln_clim).AND.(imois/=nbdy_b_bt) ) THEN ! remember that nbdy_b_bt=0 for kt=nit000
          nbdy_b_bt = imois
          nbdy_a_bt = imois+1
@@ -993,5 +1091,5 @@
          lect=.true.
 
-        ELSEIF ((.NOT.ln_bdy_clim).AND.(itimer >= istep_bt(nbdy_a_bt))) THEN
+        ELSEIF ((.NOT.ln_clim).AND.(itimer >= istep_bt(nbdy_a_bt))) THEN
           nbdy_b_bt=nbdy_a_bt
           nbdy_a_bt=nbdy_a_bt+1
@@ -1010,10 +1108,10 @@
           ipj=1
           ipk=jpk
-          igrd=1
+          igrd=4
           ipi=nblendta(igrd)
 
           
           ! ssh
-          igrd=1
+          igrd=4
           ipi=nblendta(igrd)
 
@@ -1025,5 +1123,5 @@
 
           ! u-velocity
-          igrd=2
+          igrd=5
           ipi=nblendta(igrd)
 
@@ -1035,5 +1133,5 @@
 
           ! v-velocity
-          igrd=3
+          igrd=6
           ipi=nblendta(igrd)
 
@@ -1045,7 +1143,7 @@
 
 
-         IF(lwp) WRITE(numout,*) 'bdy_dta : first record file used nbdy_b_bt ',nbdy_b_bt
+         IF(lwp) WRITE(numout,*) 'bdy_dta_fla : first record file used nbdy_b_bt ',nbdy_b_bt
          IF(lwp) WRITE(numout,*) '~~~~~~~~  last  record file used nbdy_a_bt ',nbdy_a_bt
-         IF (.NOT.ln_bdy_clim) THEN
+         IF (.NOT.ln_clim) THEN
            IF(lwp) WRITE(numout,*) 'first  record time (s): ', istep_bt(nbdy_b_bt)
            IF(lwp) WRITE(numout,*) 'model time (s)        : ', itimer
@@ -1058,5 +1156,5 @@
       ! ***************************
     
-        IF (ln_bdy_clim) THEN
+        IF (ln_clim) THEN
           zxy = REAL( nday, wp ) / REAL( nmonth_len(nbdy_b_bt), wp ) + 0.5 - i15
         ELSE          
@@ -1064,5 +1162,5 @@
         END IF
 
-          igrd=1
+          igrd=4
           DO ib=1, nblen(igrd)
             sshbdy(ib) = zxy      * sshbdydta(ib,2) + &
@@ -1070,5 +1168,5 @@
           END DO
 
-          igrd=2
+          igrd=5
           DO ib=1, nblen(igrd)
             ubtbdy(ib) = zxy      * ubtbdydta(ib,2) + &
@@ -1076,5 +1174,5 @@
           END DO
 
-          igrd=3
+          igrd=6
           DO ib=1, nblen(igrd)
             vbtbdy(ib) = zxy      * vbtbdydta(ib,2) + &
@@ -1083,5 +1181,5 @@
 
 
-      END IF !end if ((nbdy_dta==1).AND.(ntimes_bdy_bt>1))
+      END IF !end if ((nn_dtactl==1).AND.(ntimes_bdy_bt>1))
     
       ! ------------------- !
@@ -1090,5 +1188,5 @@
 
       ! Closing of the 3 files
-      IF( kt == nitend ) THEN
+      IF( kt == nitend   .and. jit == icycl ) THEN
           CALL iom_close( numbdyt_bt )
           CALL iom_close( numbdyu_bt )
@@ -1096,7 +1194,7 @@
       ENDIF
 
-      ENDIF ! ln_bdy_dyn_frs
-
-      END SUBROUTINE bdy_dta_bt
+      ENDIF ! ln_dyn_frs
+
+      END SUBROUTINE bdy_dta_fla
 
 
@@ -1106,10 +1204,10 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE bdy_dta( kt )              ! Empty routine
-      WRITE(*,*) 'bdy_dta: You should not have seen this print! error?', kt
-   END SUBROUTINE bdy_dta
-   SUBROUTINE bdy_dta_bt( kt, kit )      ! Empty routine
-      WRITE(*,*) 'bdy_dta: You should not have seen this print! error?', kt, kit
-   END SUBROUTINE bdy_dta_bt
+   SUBROUTINE bdy_dta_frs( kt )              ! Empty routine
+      WRITE(*,*) 'bdy_dta_frs: You should not have seen this print! error?', kt
+   END SUBROUTINE bdy_dta_frs
+   SUBROUTINE bdy_dta_fla( kt, kit, icycle )      ! Empty routine
+      WRITE(*,*) 'bdy_dta_frs: You should not have seen this print! error?', kt, kit
+   END SUBROUTINE bdy_dta_fla
 #endif
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 2528)
@@ -8,4 +8,6 @@
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
    !!            3.2  !  2008-04  (R. Benshila) consider velocity instead of transport 
+   !!            3.3  !  2010-09  (E.O'Dea) modifications for Shelf configurations 
+   !!            3.3  !  2010-09  (D.Storkey) add ice boundary conditions
    !!----------------------------------------------------------------------
 #if defined key_bdy 
@@ -34,9 +36,8 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -54,47 +55,51 @@
       INTEGER, INTENT( in ) ::   kt   ! Main time step counter
       !!
-      INTEGER  ::   ib, ik, igrd      ! dummy loop indices
-      INTEGER  ::   ii, ij            ! 2D addresses
-      REAL(wp) ::   zwgt              ! boundary weight
+      INTEGER  ::   jb, jk         ! dummy loop indices
+      INTEGER  ::   ii, ij, igrd   ! local integers
+      REAL(wp) ::   zwgt           ! boundary weight
       !!----------------------------------------------------------------------
       !
-      IF(ln_bdy_dyn_frs) THEN ! If this is false, then this routine does nothing. 
-
+      IF(ln_dyn_frs) THEN       ! If this is false, then this routine does nothing. 
+         !
          IF( kt == nit000 ) THEN
             IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) 'bdy_dyn : Flow Relaxation Scheme on momentum'
+            IF(lwp) WRITE(numout,*) 'bdy_dyn_frs : Flow Relaxation Scheme on momentum'
             IF(lwp) WRITE(numout,*) '~~~~~~~'
          ENDIF
          !
          igrd = 2                      ! Relaxation of zonal velocity
-         DO ib = 1, nblen(igrd)
-            DO ik = 1, jpkm1
-               ii = nbi(ib,igrd)
-               ij = nbj(ib,igrd)
-               zwgt = nbw(ib,igrd)
-               ua(ii,ij,ik) = ( ua(ii,ij,ik) * ( 1.- zwgt ) + ubdy(ib,ik) * zwgt ) * umask(ii,ij,ik)
+         DO jb = 1, nblen(igrd)
+            DO jk = 1, jpkm1
+               ii   = nbi(jb,igrd)
+               ij   = nbj(jb,igrd)
+               zwgt = nbw(jb,igrd)
+               ua(ii,ij,jk) = ( ua(ii,ij,jk) * ( 1.- zwgt ) + ubdy(jb,jk) * zwgt ) * umask(ii,ij,jk)
             END DO
          END DO
          !
          igrd = 3                      ! Relaxation of meridional velocity
-         DO ib = 1, nblen(igrd)
-            DO ik = 1, jpkm1
-               ii = nbi(ib,igrd)
-               ij = nbj(ib,igrd)
-               zwgt = nbw(ib,igrd)
-               va(ii,ij,ik) = ( va(ii,ij,ik) * ( 1.- zwgt ) + vbdy(ib,ik) * zwgt ) * vmask(ii,ij,ik)
+         DO jb = 1, nblen(igrd)
+            DO jk = 1, jpkm1
+               ii   = nbi(jb,igrd)
+               ij   = nbj(jb,igrd)
+               zwgt = nbw(jb,igrd)
+               va(ii,ij,jk) = ( va(ii,ij,jk) * ( 1.- zwgt ) + vbdy(jb,jk) * zwgt ) * vmask(ii,ij,jk)
             END DO
          END DO 
+         CALL lbc_lnk( ua, 'U', -1. )   ;   CALL lbc_lnk( va, 'V', -1. )   ! Boundary points should be updated
          !
-         CALL lbc_lnk( ua, 'U', -1. )   ! Boundary points should be updated
-         CALL lbc_lnk( va, 'V', -1. )   !
-         !
-      ENDIF ! ln_bdy_dyn_frs
-
+      ENDIF ! ln_dyn_frs
+      !
    END SUBROUTINE bdy_dyn_frs
 
 
-#if defined key_dynspg_exp || defined key_dynspg_ts
+# if defined   key_dynspg_exp   ||   defined key_dynspg_ts
+   !!----------------------------------------------------------------------
+   !!   'key_dynspg_exp'        OR              explicit sea surface height
+   !!   'key_dynspg_ts '                  split-explicit sea surface height
+   !!----------------------------------------------------------------------
+   
 !! Option to use Flather with dynspg_flt not coded yet...
+
    SUBROUTINE bdy_dyn_fla( pssh )
       !!----------------------------------------------------------------------
@@ -102,5 +107,5 @@
       !!             
       !!              - Apply Flather boundary conditions on normal barotropic velocities 
-      !!                (ln_bdy_dyn_fla=.true. or ln_bdy_tides=.true.)
+      !!                (ln_dyn_fla=.true. or ln_tides=.true.)
       !!
       !! ** WARNINGS about FLATHER implementation:
@@ -119,5 +124,5 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in) ::   pssh
 
-      INTEGER  ::   ib, igrd                         ! dummy loop indices
+      INTEGER  ::   jb, igrd                         ! dummy loop indices
       INTEGER  ::   ii, ij, iim1, iip1, ijm1, ijp1   ! 2D addresses
       REAL(wp) ::   zcorr                            ! Flather correction
@@ -129,44 +134,46 @@
       ! ---------------------------------! 
      
-      IF(ln_bdy_dyn_fla .OR. ln_bdy_tides) THEN ! If these are both false, then this routine does nothing. 
+      IF(ln_dyn_fla .OR. ln_tides) THEN ! If these are both false, then this routine does nothing. 
 
          ! Fill temporary array with ssh data (here spgu):
-         igrd = 1
+         igrd = 4
          spgu(:,:) = 0.0
-         DO ib = 1, nblenrim(igrd)
-            ii = nbi(ib,igrd)
-            ij = nbj(ib,igrd)
-            IF( ln_bdy_dyn_fla ) spgu(ii, ij) = sshbdy(ib)
-            IF( ln_bdy_tides )   spgu(ii, ij) = spgu(ii, ij) + sshtide(ib)
+         DO jb = 1, nblenrim(igrd)
+            ii = nbi(jb,igrd)
+            ij = nbj(jb,igrd)
+            IF( ln_dyn_fla ) spgu(ii, ij) = sshbdy(jb)
+            IF( ln_tides )   spgu(ii, ij) = spgu(ii, ij) + sshtide(jb)
          END DO
          !
-         igrd = 2      ! Flather bc on u-velocity; 
+         igrd = 5      ! Flather bc on u-velocity; 
          !             ! remember that flagu=-1 if normal velocity direction is outward
          !             ! I think we should rather use after ssh ?
-         DO ib = 1, nblenrim(igrd)
-            ii  = nbi(ib,igrd)
-            ij  = nbj(ib,igrd) 
-            iim1 = ii + MAX( 0, INT( flagu(ib) ) )   ! T pts i-indice inside the boundary
-            iip1 = ii - MIN( 0, INT( flagu(ib) ) )   ! T pts i-indice outside the boundary 
+         DO jb = 1, nblenrim(igrd)
+            ii  = nbi(jb,igrd)
+            ij  = nbj(jb,igrd) 
+            iim1 = ii + MAX( 0, INT( flagu(jb) ) )   ! T pts i-indice inside the boundary
+            iip1 = ii - MIN( 0, INT( flagu(jb) ) )   ! T pts i-indice outside the boundary 
             !
-            zcorr = - flagu(ib) * SQRT( grav * hur_e(ii, ij) ) * ( pssh(iim1, ij) - spgu(iip1,ij) )
-            zforc = ubtbdy(ib) + utide(ib)
+            zcorr = - flagu(jb) * SQRT( grav * hur_e(ii, ij) ) * ( pssh(iim1, ij) - spgu(iip1,ij) )
+            zforc = ubtbdy(jb) + utide(jb)
             ua_e(ii,ij) = zforc + zcorr * umask(ii,ij,1) 
          END DO
          !
-         igrd = 3      ! Flather bc on v-velocity
+         igrd = 6      ! Flather bc on v-velocity
          !             ! remember that flagv=-1 if normal velocity direction is outward
-         DO ib = 1, nblenrim(igrd)
-            ii  = nbi(ib,igrd)
-            ij  = nbj(ib,igrd) 
-            ijm1 = ij + MAX( 0, INT( flagv(ib) ) )   ! T pts j-indice inside the boundary
-            ijp1 = ij - MIN( 0, INT( flagv(ib) ) )   ! T pts j-indice outside the boundary 
+         DO jb = 1, nblenrim(igrd)
+            ii  = nbi(jb,igrd)
+            ij  = nbj(jb,igrd) 
+            ijm1 = ij + MAX( 0, INT( flagv(jb) ) )   ! T pts j-indice inside the boundary
+            ijp1 = ij - MIN( 0, INT( flagv(jb) ) )   ! T pts j-indice outside the boundary 
             !
-            zcorr = - flagv(ib) * SQRT( grav * hvr_e(ii, ij) ) * ( pssh(ii, ijm1) - spgu(ii,ijp1) )
-            zforc = vbtbdy(ib) + vtide(ib)
+            zcorr = - flagv(jb) * SQRT( grav * hvr_e(ii, ij) ) * ( pssh(ii, ijm1) - spgu(ii,ijp1) )
+            zforc = vbtbdy(jb) + vtide(jb)
             va_e(ii,ij) = zforc + zcorr * vmask(ii,ij,1)
          END DO
+         CALL lbc_lnk( ua_e, 'U', -1. )   ! Boundary points should be updated
+         CALL lbc_lnk( va_e, 'V', -1. )   !
          !
-      ENDIF ! ln_bdy_dyn_fla .or. ln_bdy_tides
+      ENDIF ! ln_dyn_fla .or. ln_tides
       !
    END SUBROUTINE bdy_dyn_fla
Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice.F90	(revision 2528)
@@ -0,0 +1,84 @@
+MODULE bdyice
+   !!======================================================================
+   !!                       ***  MODULE  bdyice  ***
+   !! Unstructured Open Boundary Cond. :  Flow Relaxation Scheme applied sea-ice
+   !!======================================================================
+   !!  History :  3.3  !  2010-09 (D. Storkey)  Original code
+   !!----------------------------------------------------------------------
+#if defined   key_bdy   &&   defined key_lim2
+   !!----------------------------------------------------------------------
+   !!   'key_bdy'            and                 Unstructured Open Boundary Conditions
+   !!   'key_lim2'                                                 LIM-2 sea ice model
+   !!----------------------------------------------------------------------
+   !!   bdy_ice_frs        : Relaxation of tracers on unstructured open boundaries
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers variables
+   USE ice_2           ! LIM_2 ice variables
+   USE dom_oce         ! ocean space and time domain variables 
+   USE bdy_oce         ! ocean open boundary conditions
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE in_out_manager  ! write to numout file
+   
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   bdy_ice_frs    ! routine called in sbcmod
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE bdy_ice_frs( kt )
+      !!------------------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_ice_frs  ***
+      !!                    
+      !! ** Purpose : Apply the Flow Relaxation Scheme for sea-ice fields in the case 
+      !!              of unstructured open boundaries. Currently only tested for LIM2.
+      !! 
+      !! Reference : Engedahl H., 1995: Use of the flow relaxation scheme in a three-
+      !!             dimensional baroclinic ocean model with realistic topography. Tellus, 365-382.
+      !!------------------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt   ! model time step index
+      !!
+      INTEGER  ::   jb, jk, jgrd   ! dummy loop indices
+      INTEGER  ::   ii, ij         ! local scalar
+      REAL(wp) ::   zwgt, zwgt1    ! local scalar
+      !!------------------------------------------------------------------------------
+      !
+      jgrd = 1      ! Everything is at T-points here
+      !
+      IF( ln_ice_frs ) THEN     ! update ice fields by relaxation at the boundary
+         DO jb = 1, nblen(jgrd)
+            DO jk = 1, jpkm1
+               ii    = nbi(jb,jgrd)
+               ij    = nbj(jb,jgrd)
+               zwgt  = nbw(jb,jgrd)
+               zwgt1 = 1.e0 - nbw(jb,jgrd)
+               frld (ii,ij) = ( frld (ii,ij) * zwgt1 + frld_bdy (jb) * zwgt ) * tmask(ii,ij,1)     ! Leads fraction 
+               hicif(ii,ij) = ( hicif(ii,ij) * zwgt1 + hicif_bdy(jb) * zwgt ) * tmask(ii,ij,1)     ! Ice depth 
+               hsnif(ii,ij) = ( hsnif(ii,ij) * zwgt1 + hsnif_bdy(jb) * zwgt ) * tmask(ii,ij,1)     ! Snow depth
+            END DO
+         END DO 
+         CALL lbc_lnk( frld, 'T', 1. )                                         ! lateral boundary conditions
+         CALL lbc_lnk( hicif, 'T', 1. )   ;   CALL lbc_lnk( hsnif, 'T', 1. )
+         !
+      ELSE                          ! we have called this routine without ln_ice_frs not set
+         IF( kt == nit000 )   CALL ctl_warn( 'E R R O R (possible) called bdy_ice_frs when ln_ice_frs is false?' )
+      ENDIF
+      !      
+   END SUBROUTINE bdy_ice_frs
+#else
+   !!---------------------------------------------------------------------------------
+   !!   Default option                                                    Empty module
+   !!---------------------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE bdy_ice_frs( kt )      ! Empty routine
+      WRITE(*,*) 'bdy_ice_frs: You should not have seen this print! error?', kt
+   END SUBROUTINE bdy_ice_frs
+#endif
+
+   !!=================================================================================
+END MODULE bdyice
